#include <SDL_events.h>
#include "sdl_joy.h"


int 
GetJoyEvent()
{
  static int IsButtonPressed=0;
  static int RepeatMode=0;
  static int LastButtonPressed=JOY_NOEVENT;
  static int LastTime=0;

  int Event=JOY_NOEVENT;
    
  do {
  
    SDL_Event SDLEvent;    
    int i=0;
    while(!SDL_PollEvent(&SDLEvent)) {
      if ( ((SDL_GetTicks()-LastTime>DELAY_KEY_FIRST) || 
           ((SDL_GetTicks()-LastTime>DELAY_KEY_REPEAT) && RepeatMode)) && 
           IsButtonPressed && (LastButtonPressed!=JOY_NOEVENT)) {
        RepeatMode=1;
        LastTime = SDL_GetTicks();
        return LastButtonPressed;
      }
    }

    LastTime=SDL_GetTicks();
  
#ifdef GP2X_MODE
    if (SDLEvent.type==SDL_JOYBUTTONDOWN) {
      Event=SDLEvent.jbutton.button;
      IsButtonPressed=1;
      LastButtonPressed=Event;
    } else {
      Event=JOY_NOEVENT;
    }
      
    if (SDLEvent.type==SDL_JOYBUTTONUP) {
      IsButtonPressed=0;
      RepeatMode=0;
    }
#else
    if (SDLEvent.type==SDL_KEYDOWN) {
      Event=((SDL_KeyboardEvent*)(&SDLEvent))->keysym.scancode;
      IsButtonPressed=1;
      LastButtonPressed=Event;
    } else {
      Event=JOY_NOEVENT;
    }
      
    if (SDLEvent.type==SDL_KEYUP) {
      IsButtonPressed=0;
      RepeatMode=0;
    }    
#endif
  }
  while (Event==JOY_NOEVENT);

  return Event;
}

